/*
*/

#pragma once
#ifndef RADAR_H
#define RADAR_H

#include "../player.h"

struct TURFCoords
{
	int x, y;
};

struct TURFRect
{
	TURFCoords ul, lr;
};

struct TURFFlag
{
	int flag_id;
	int team;
};

#define BUFFER_LEN 256

struct TURFBase
{
	int index, max;
	bool red;

	_linkedlist <TURFRect> regions;
	_linkedlist <TURFFlag> flags;

	TURFFlag *find_flag(Uint16 ident)
	{
		_listnode <TURFFlag> *node = flags.head;

		while (node)
		{
			TURFFlag *flag = node->item;

			if (flag->flag_id == ident)
				return flag;

			node = node->next;
		}

		return NULL;
	}

	bool is_red()
	{
		_listnode <TURFFlag> *node = flags.head;
		int count = 0;

		while (node)
		{
			TURFFlag *flag = node->item;

			if (flag->team == 1)
				++count;

			node = node->next;
		}

		return (count >= max / 2);
	}
};

struct TURFSettings
{
	_linkedlist <TURFBase> bases;

	TURFBase *inside(int x, int y)
	{
		_listnode <TURFBase> *node = bases.head;

		while (node)
		{
			TURFBase *base = node->item;

			_listnode <TURFRect> *rnode = base->regions.head;

			while (rnode)
			{
				TURFRect *rect = rnode->item;

				if (rect->ul.x <= x)
				if (rect->ul.y <= y)
				if (rect->lr.x >= x)
				if (rect->lr.y >= y)
				{
					return base;
				}

				rnode = rnode->next;
			}

			node = node->next;
		}

		return NULL;
	}
};

void LoadSettings(TURFSettings &setts);

#endif	// RADAR_H
